namespace sGUI

declare function AddCheckMarkGadget (event as EventHandle ptr,PosX as integer,PosY as integer,SwtchSel as integer,Text as string="") as Gadget ptr
declare function CheckMarkGadgetActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawCheckMarkGadget (gad as Gadget ptr)
declare sub UpdateCheckMark (gad as Gadget ptr)

function AddCheckmarkGadget (event as EventHandle ptr,PosX as integer,PosY as integer,SwtchSel as integer, Text as string="") as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event
  	gad->sel=SwtchSel
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    /'
    if Text="" then
      gad->gadw=16
    else
      gad->gadw=20 + len(Text)*8
    end if
    if fontheight=8 then
      gad->gadh=12
    else
      gad->gadh=fontheight
    end if    
    '/   
    if Text="" then   
      gad->gadw=sGUIMainsize
      gad->gadh=sGUIMainsize
    else
      'beide Flle knnen auftreten wenn sGUIMainSize manuell definiert wird
      'jedenfalls entspricht die Gadgethhe danach entweder der Fonthhe, wenn diese Grer ist, anderenfalls halt der sGUIMainSize      
      if sGUIMainSize>=GetFontHeight then
        gad->gadw=sGUIMainSize + sGUIMainGap + GetTextWidth(Text)
        gad->gadh=sGUIMainSize              
      else'GetFontHeight>sGUIMainSize   
        gad->gadw=GetFontHeight + sGUIMainGap + GetTextWidth(Text)
        gad->gadh=GetFontHeight        
      end if      
    end if
    
    gad->caption=Text

    gad->DoDraw     =@DrawCheckMarkGadget
    gad->DoAction   =@CheckMarkGadgetActions
    gad->DoUpdate   =@UpdateCheckMark

		gad->SaveBackGround
		function=gad
  end if
end function


function CheckMarkGadgetActions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action
      
      case GADGET_HIT        'Control grad frisch gedrckt

      case GADGET_HOLD       'Control wird gehalten, Maus ber dem Control

      case GADGET_HOLDOFF    'Control wird gehalten, Maus neben dem Control

      case GADGET_RELEASE    'Control regulr losgelassen
        if GetSelect(gad) then SetSelect(gad,0) else SetSelect(gad,1)
         function=1
      case GADGET_RELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control
      
      case GADGET_MOUSEOVER     'Control ist losgelassen, dabei ist Maus berm dem Control
        gad->over=1
        DrawGadget(gad)
        
      case GADGET_MOUSENEXT     'Control ist losgelassen, dabei ist Maus nun neben dem Control
        gad->over=0
        DrawGadget(gad) 

end select
end function



sub DrawCheckmarkGadget (gad as gadget ptr)
	dim as integer PosX,PosY,GadWidth,GadHeight',txtv,boxv
  dim as integer symbolsize,symboloffset,textoffsety,boxoffsety
  dim as string Text
  PosX   =gad->posx
	PosY   =gad->posy
	GadWidth		=gad->gadw
	GadHeight		=gad->gadh
  'txtv=(GadHeight-fontheight)\2
  'boxv=(GadHeight-12)\2
  textoffsety=(GadHeight-GetFontHeight)/2
  boxoffsety=(GadHeight-sGUIMainSize)/2
  symbolsize=sGUIMainSize*.66
  symboloffset=(sGUIMainSize-symbolsize)/2  
  screenlock
'OFF
    put(PosX,PosY),gad->Background,pset  
'ON
    if gad->act then
      'FillB PosX+boxv,PosY+boxv,12,12,GadgetColor,gad->sel
      FillB PosX,PosY+boxoffsety,sGUIMainSize,sGUIMainSize,GadgetColor,gad->sel
      
      'if gad->sel then Tick (PosX+boxv+2,PosY+boxv+2,GadgetTextColor)
      if gad->sel then Symbol_CheckMark (PosX+symboloffset,PosY+boxoffsety+symboloffset,symbolsize,GadgetTextColor)
      'draw string (PosX+20,PosY+txtv),gad->caption,TextColor
      drawstring (0,PosX+GadHeight+sGUIMainGap,PosY+textoffsety,gad->caption,TextColor)
'SLEEP
      if gad->act=2 then put(PosX,PosY),gad->Background,alpha,SleepShade
    end if
  screenunlock
end sub



sub UpdateCheckMark (gad as Gadget ptr)
  put(gad->posx,gad->posy),gad->Background,pset  'Restaurieren des originalen Screenhintergrundes
  gad->gadw=20+len(gad->caption)*8                       'neue Breite nach Lnge des neuen String setzen
  gad->SaveBackground                                 'Hintergrund sichern
  DrawGadget(gad)                                     'Neuzeichnen  
end sub

end namespace
