namespace sGUI

declare function AddRadioButton (event as EventHandle ptr,PosX as integer,PosY as integer,SwtchSel as integer,Text as string="",Head as Gadget ptr) as Gadget ptr
declare function RadioButtonActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawRadioButton (gad as Gadget ptr)
declare sub UpdateRadioButton (gad as Gadget ptr)

'Steuerungsvariablen:
'Ctrl(0) erster RB
'Ctrl(1) letzte RB (nur im Head RB definiert)
'Ctrl(2) nachfolgender RB
function AddRadioButton (event as EventHandle ptr,PosX as integer,PosY as integer,SwtchSel as integer,Text as string="",Head as Gadget ptr) as Gadget ptr
  function=0
  dim as Gadget ptr gad,groupfirst
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event
  	gad->sel=SwtchSel
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    /'
    if Text="" then
      gad->gadw=16
    else
      gad->gadw=20 + len(Text)*8
    end if
    if fontheight=8 then
      gad->gadh=12
    else
      gad->gadh=fontheight
    end if
    '/
    if Text="" then   
      gad->gadw=sGUIMainsize
      gad->gadh=sGUIMainsize
    else
      'beide Flle knnen auftreten wenn sGUIMainSize manuell definiert wird
      'jedenfalls entspricht die Gadgethhe danach entweder der Fonthhe, wenn diese Grer ist, anderenfalls halt der sGUIMainSize      
      if sGUIMainSize>=GetFontHeight then
        gad->gadw=sGUIMainSize + sGUIMainGap + GetTextWidth(Text)
        gad->gadh=sGUIMainSize              
      end if
      
      if GetFontHeight>sGUIMainSize then      
        gad->gadw=GetFontHeight + sGUIMainGap + GetTextWidth(Text)
        gad->gadh=GetFontHeight        
      end if      
    end if    

    gad->caption=Text
    
    if Head=0 then
      gad->TObject=new TextObject
    else
      gad->TObject=Head->TObject
    end if
    TO_AppendLine(gad,str(gad))'neue Zeile hinzufgen, Adresse dieses RBs reinschreiben
    
    gad->DoDraw     =@DrawRadioButton
    gad->DoAction   =@RadioButtonActions
    gad->DoUpdate   =@UpdateRadioButton

		gad->SaveBackGround
		function=gad
  end if
end function


function RadioButtonActions(gad as Gadget ptr,action as integer) as integer
  dim as Gadget ptr g
  dim as integer l
  function=0
  select case action
      
      case GADGET_HIT        'Control grad frisch gedrckt

      case GADGET_HOLD       'Control wird gehalten, Maus ber dem Control

      case GADGET_HOLDOFF    'Control wird gehalten, Maus neben dem Control

      case GADGET_RELEASE    'Control regulr losgelassen
        l=TO_GetLines(gad)
        if l then
          for i as integer=1 to l
            
            #if defined (__fb_64bit__) 
              g=cast(Gadget ptr, vallng( TO_GetLineContent(gad,i) ) )                
            #else
              g=cast(Gadget ptr, valint( TO_GetLineContent(gad,i) ) )      
            #endif             
                       
            if g=gad then SetSelect(g,1) else SetSelect(g,0)
          next i
          function=1
        end if
      case GADGET_RELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control

  end select
end function



sub DrawRadioButton (gad as Gadget ptr)
	dim as integer PosX,PosY,GadWidth,GadHeight',txtv,boxv
  dim as integer frameradius,symbolradius,symboloffset,textoffsety,frameoffsety  
  dim as string Text
  PosX   =gad->posx
	PosY   =gad->posy
	GadWidth		=gad->gadw
	GadHeight		=gad->gadh
  'txtv=(GadHeight-fontheight)\2
  'boxv=(GadHeight-12)\2
  textoffsety=(GadHeight-GetFontHeight)/2  
  frameradius=sGUIMainSize/2
  frameoffsety=(GadHeight-sGUIMainSize)/2
  symbolradius=frameradius*.5
  screenlock
'OFF	
    put(PosX,PosY),gad->Background,pset
'ON
  if gad->act then
    'FrameC PosX+boxv,PosY+boxv
    RoundFrame (PosX+frameradius,PosY+frameoffsety+frameradius,frameradius)
    'if gad->sel then Dot PosX+boxv+2,PosY+boxv+2,GadgetColor
    if gad->sel then DrawRBDot (PosX+frameradius,PosY+frameoffsety+frameradius,symbolradius)    
    'draw string (PosX+20,PosY+txtv),gad->caption,TextColor
    drawstring (0,PosX+GadHeight+sGUIMainGap,PosY+textoffsety,gad->caption,TextColor)  
'SLEEP    
    if gad->act=2 then put(PosX,PosY),gad->Background,alpha,SleepShade
  end if
	screenunlock
end sub



sub UpdateRadioButton (gad as Gadget ptr)
  put(gad->posx,gad->posy),gad->Background,pset  'Restaurieren des originalen Screenhintergrundes
  gad->gadw=len(gad->caption)*8                       'neue Breite nach Lnge des neuen String setzen
  gad->SaveBackground                                 'Hintergrund sichern
  DrawGadget(gad)                                     'Neuzeichnen
end sub

end namespace