namespace sGUI

declare function AddToggleGadget (event as EventHandle ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0,s as integer,Text as string) as Gadget ptr
declare function ToggleGadgetActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawToggleGadget (gad as Gadget ptr)

function AddToggleGadget (event as EventHandle ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0,s as integer,Text as string) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event
  	gad->sel=s
    gad->act=0
    gad->PosX=PosX
    gad->posy=PosY
		if GadWidth=0 then GadWidth=GetTextWidth(Text)+2*sGUIMainGap
		if GadHeight=0 then GadHeight=GetFontHeight+2*sGUIMainGap    
    gad->gadw=GadWidth
    gad->gadh=GadHeight

    gad->caption=Text

    gad->DoDraw     =@DrawToggleGadget
    gad->DoAction   =@ToggleGadgetActions
    gad->DoUpdate   =@DrawToggleGadget

		gad->SaveBackGround
		function=gad
  end if
end function



function ToggleGadgetActions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action
      
      case GADGET_HIT        'Control grad frisch gedrckt

      case GADGET_HOLD       'Control wird gehalten, Maus ber dem Control

      case GADGET_HOLDOFF    'Control wird gehalten, Maus neben dem Control

      case GADGET_RELEASE    'Control regulr losgelassen
        if GetSelect(gad) then SetSelect(gad,0) else SetSelect(gad,1)
         function=1
      case GADGET_RELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control

  end select
end function



sub DrawToggleGadget (gad as Gadget ptr)
	dim as integer PosX,PosY,GadWidth,GadHeight
  'dim as string txtu,txts
  dim as integer TextPosX,TextPosY  
  PosX   =gad->PosX
	PosY   =gad->posy
	GadWidth		=gad->gadw
	GadHeight		=gad->gadh  
  TextPosX=(GadWidth-GetTextWidth(gad->caption))/2
  TextPosY=(GadHeight-GetFontHeight)/2  
  screenlock
    if gad->act=0 then
'OFF
      put(PosX,PosY),gad->Background,pset
    else
'ON   unselect/select
      FrameB PosX, PosY, GadWidth, GadHeight,gad->sel
      FillA PosX+1,PosY+1,GadWidth-2,GadHeight-2,GadgetColor,gad->sel
      if gad->sel then'unselect/select Caption
        'draw string ( PosX+(GadWidth-len(gad->caption)*8)/2 +1, PosY+(GadHeight-fontheight)/2+1 ),gad->caption,GadgetTextColor
        'draw string ( PosX+(GadWidth-len(gad->caption)*8)/2 , PosY+(GadHeight-fontheight)/2 ),gad->caption,white
        drawstring (0,PosX+TextPosX+1 , PosY+TextPosY+1,gad->caption,GadgetTextColor)
        drawstring (0,PosX+TextPosX , PosY+TextPosY,gad->caption,white)      
      else
        'draw string ( PosX+(GadWidth-len(gad->caption)*8)/2 , PosY+(GadHeight-fontheight)/2 ),gad->caption,GadgetTextColor
        drawstring (0,PosX+TextPosX , PosY+TextPosY,gad->caption,GadgetTextColor)        
      end if         
'SLEEP
      if gad->act=2 then put(PosX,PosY),gad->Background,alpha,SleepShade
    end if
  screenunlock  
end sub

end namespace
